Index: python/CONTROL.temp
===================================================================
--- python/CONTROL.temp	(revision d69b6776d6d39e0af0d38c95cbfd78284c9866e4)
+++ python/CONTROL.temp	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -10,10 +10,10 @@
 EXPVER 1
 GRID 5000  
-LEFT -175000
-LOWER -90000
-UPPER 90000
-RIGHT 180000
+LEFT -15000
+LOWER 30000
+UPPER 75000
+RIGHT 45000
 LEVEL 60
-LEVELIST 1/to/60
+LEVELIST 55/to/60
 RESOL 63
 GAUSS 1
@@ -27,6 +27,6 @@
 FORMAT GRIB1
 ADDPAR 186/187/188/235/139/39
-PREFIX EN
-ECSTORAGE 1
+PREFIX EI
+ECSTORAGE 0
 ECTRANS 0
 ECFSDIR ectmp:/${USER}/econdemand/
Index: python/Control.py
===================================================================
--- python/Control.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/Control.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,259 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+#************************************************************************
+# TODO AP
+# - write a test class
+# - check documentation
+#************************************************************************
+"""
+@Author: Leopold Haimberger (University of Vienna)
+
+@Date: November 2015
+
+@ChangeHistory:
+   February 2018 - Anne Philipp (University of Vienna):
+        - applied PEP8 style guide
+        - added documentation
+        - applied some minor modifications in programming style/structure
+        - outsource of class Control
+
+@License:
+    (C) Copyright 2015-2018.
+
+    This software is licensed under the terms of the Apache Licence Version 2.0
+    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+
+@Requirements:
+    A standard python 2.6 or 2.7 installation
+
+@Description:
+    The Control files are the steering part of the FLEXPART extraction
+    software. All necessary parameters needed to retrieve the data fields
+    from the MARS archive for driving FLEXPART are set in a Control file.
+    Some specific parameters like the start and end dates can be overwritten
+    by the command line parameters, but in generel all parameters needed
+    for a complete set of fields for FLEXPART can be set in the Control files.
+
+"""
+# ------------------------------------------------------------------------------
+# MODULES
+# ------------------------------------------------------------------------------
+import os
+import inspect
+import Tools
+# ------------------------------------------------------------------------------
+# CLASS
+# ------------------------------------------------------------------------------
+class Control:
+    '''
+    Class containing the information of the ECMWFDATA control file.
+
+    Contains all the parameters of control files, which are e.g.:
+    DAY1(start_date), DAY2(end_date), DTIME, MAXSTEP, TYPE, TIME,
+    STEP, CLASS(marsclass), STREAM, NUMBER, EXPVER, GRID, LEFT,
+    LOWER, UPPER, RIGHT, LEVEL, LEVELIST, RESOL, GAUSS, ACCURACY,
+    OMEGA, OMEGADIFF, ETA, ETADIFF, DPDETA, SMOOTH, FORMAT,
+    ADDPAR, WRF, CWC, PREFIX, ECSTORAGE, ECTRANS, ECFSDIR,
+    MAILOPS, MAILFAIL, GRIB2FLEXPART, FLEXPARTDIR,
+    BASETIME, DATE_CHUNK, DEBUG, INPUTDIR, OUTPUTDIR, FLEXPART_ROOT_SCRIPTS
+
+    For more information about format and content of the parameter
+    see documentation.
+
+    '''
+
+    def __init__(self, filename):
+        '''
+        @Description:
+            Initialises the instance of Control class and defines and
+            assign all controlfile variables. Set default values if
+            parameter was not in CONTROL file.
+
+        @Input:
+            self: instance of Control class
+                Description see class documentation.
+
+            filename: string
+                Name of control file.
+
+        @Return:
+            <nothing>
+        '''
+
+        # read whole CONTROL file
+        with open(filename) as f:
+            fdata = f.read().split('\n')
+
+        # go through every line and store parameter
+        # as class variable
+        for ldata in fdata:
+            data = ldata.split()
+            if len(data) > 1:
+                if 'm_' in data[0].lower():
+                    data[0] = data[0][2:]
+                if data[0].lower() == 'class':
+                    data[0] = 'marsclass'
+                if data[0].lower() == 'day1':
+                    data[0] = 'start_date'
+                if data[0].lower() == 'day2':
+                    data[0] = 'end_date'
+                if data[0].lower() == 'addpar':
+                    if '/' in data[1]:
+                        # remove leading '/' sign from addpar content
+                        if data[1][0] == '/':
+                            data[1] = data[1][1:]
+                        dd = data[1].split('/')
+                        data = [data[0]]
+                        for d in dd:
+                            data.append(d)
+                    pass
+                if len(data) == 2:
+                    if '$' in data[1]:
+                        setattr(self, data[0].lower(), data[1])
+                        while '$' in data[1]:
+                            i = data[1].index('$')
+                            j = data[1].find('{')
+                            k = data[1].find('}')
+                            var = os.getenv(data[1][j+1:k])
+                            if var is not None:
+                                data[1] = data[1][:i] + var + data[1][k+1:]
+                            else:
+                                Tools.myerror(None,
+                                              'Could not find variable ' +
+                                              data[1][j+1:k] +
+                                              ' while reading ' +
+                                              filename)
+                        setattr(self, data[0].lower() + '_expanded', data[1])
+                    else:
+                        if data[1].lower() != 'none':
+                            setattr(self, data[0].lower(), data[1])
+                        else:
+                            setattr(self, data[0].lower(), None)
+                elif len(data) > 2:
+                    setattr(self, data[0].lower(), (data[1:]))
+            else:
+                pass
+
+        # check a couple of necessary attributes if they contain values
+        # otherwise set default values
+        if not hasattr(self, 'start_date'):
+            self.start_date = None
+        if not hasattr(self, 'end_date'):
+            self.end_date = self.start_date
+        if not hasattr(self, 'accuracy'):
+            self.accuracy = 24
+        if not hasattr(self, 'omega'):
+            self.omega = '0'
+        if not hasattr(self, 'cwc'):
+            self.cwc = '0'
+        if not hasattr(self, 'omegadiff'):
+            self.omegadiff = '0'
+        if not hasattr(self, 'etadiff'):
+            self.etadiff = '0'
+        if not hasattr(self, 'levelist'):
+            if not hasattr(self, 'level'):
+                print('Warning: neither levelist nor level \
+                       specified in CONTROL file')
+            else:
+                self.levelist = '1/to/' + self.level
+        else:
+            if 'to' in self.levelist:
+                self.level = self.levelist.split('/')[2]
+            else:
+                self.level = self.levelist.split('/')[-1]
+
+        if not hasattr(self, 'maxstep'):
+            # find out maximum step
+            self.maxstep = 0
+            for s in self.step:
+                if int(s) > self.maxstep:
+                    self.maxstep = int(s)
+        else:
+            self.maxstep = int(self.maxstep)
+
+        if not hasattr(self, 'prefix'):
+            self.prefix = 'EN'
+        if not hasattr(self, 'makefile'):
+            self.makefile = None
+        if not hasattr(self, 'basetime'):
+            self.basetime = None
+        if not hasattr(self, 'date_chunk'):
+            self.date_chunk = '3'
+        if not hasattr(self, 'grib2flexpart'):
+            self.grib2flexpart = '0'
+
+        # script directory
+        self.ecmwfdatadir = os.path.dirname(os.path.abspath(inspect.getfile(
+            inspect.currentframe()))) + '/../'
+        # Fortran source directory
+        self.exedir = self.ecmwfdatadir + 'src/'
+
+        # FLEXPART directory
+        if not hasattr(self, 'flexpart_root_scripts'):
+            self.flexpart_root_scripts = self.ecmwfdatadir
+
+        return
+
+    def __str__(self):
+        '''
+        @Description:
+            Prepares a single string with all the comma seperated Control
+            class attributes including their values.
+
+            Example:
+            {'kids': 0, 'name': 'Dog', 'color': 'Spotted',
+             'age': 10, 'legs': 2, 'smell': 'Alot'}
+
+        @Input:
+            self: instance of Control class
+                Description see class documentation.
+
+        @Return:
+            string of Control class attributes with their values
+        '''
+
+        attrs = vars(self)
+
+        return ', '.join("%s: %s" % item for item in attrs.items())
+
+    def tolist(self):
+        '''
+        @Description:
+            Just generates a list of strings containing the attributes and
+            assigned values except the attributes "_expanded", "exedir",
+            "ecmwfdatadir" and "flexpart_root_scripts".
+
+        @Input:
+            self: instance of Control class
+                Description see class documentation.
+
+        @Return:
+            l: list
+                A sorted list of the all Control class attributes with
+                their values except the attributes "_expanded", "exedir",
+                "ecmwfdatadir" and "flexpart_root_scripts".
+        '''
+
+        attrs = vars(self)
+        l = list()
+
+        for item in attrs.items():
+            if '_expanded' in item[0]:
+                pass
+            elif 'exedir' in item[0]:
+                pass
+            elif 'flexpart_root_scripts' in item[0]:
+                pass
+            elif 'ecmwfdatadir' in item[0]:
+                pass
+            else:
+                if type(item[1]) is list:
+                    stot = ''
+                    for s in item[1]:
+                        stot += s + ' '
+
+                    l.append("%s %s" % (item[0], stot))
+                else:
+                    l.append("%s %s" % item)
+
+        return sorted(l)
Index: python/Disagg.py
===================================================================
--- python/Disagg.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/Disagg.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,156 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+#************************************************************************
+# TODO AP
+# - make a class out of this ???
+# - write a test class
+#************************************************************************
+"""
+@Author: Anne Philipp (University of Vienna)
+
+@Date: March 2018
+
+@ChangeHistory:
+    November 2015 - Leopold Haimberger (University of Vienna):
+        - integrated methods dapoly and darain from Fortran to Python
+
+    April 2018 - Anne Philipp (University of Vienna):
+        - applied PEP8 style guide
+        - added structured documentation
+        - outsourced the disaggregation functions dapoly and darain
+          to a new module named Disagg
+
+@License:
+    (C) Copyright 2015-2018.
+
+    This software is licensed under the terms of the Apache Licence Version 2.0
+    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+
+@Requirements:
+    A standard python 2.6 or 2.7 installation
+
+@Description:
+    Further documentation may be obtained from www.flexpart.eu.
+
+    Functionality provided:
+        Disaggregation of deaccumulated flux data from an ECMWF model FG field.
+        Initially the flux data to be concerned are:
+        - large-scale precipitation
+        - convective precipitation
+        - surface sensible heat flux
+        - surface solar radiation
+        - u stress
+        - v stress
+
+        Different versions of disaggregation is provided for rainfall
+        data (darain, modified linear) and the surface fluxes and
+        stress data (dapoly, cubic polynomial).
+
+"""
+# ------------------------------------------------------------------------------
+# MODULES
+# ------------------------------------------------------------------------------
+
+# ------------------------------------------------------------------------------
+# FUNCTIONS
+# ------------------------------------------------------------------------------
+def dapoly(alist):
+    '''
+    @Author: P. JAMES
+
+    @Date: 2000-03-29
+
+    @ChangeHistory:
+        June 2003     - A. BECK (2003-06-01)
+            adaptaions
+        November 2015 - Leopold Haimberger (University of Vienna)
+            migration from Fortran to Python
+
+    @Description:
+        Interpolation of deaccumulated fluxes of an ECMWF model FG field
+        using a cubic polynomial solution which conserves the integrals
+        of the fluxes within each timespan.
+        Disaggregation is done for 4 accumluated timespans which generates
+        a new, disaggregated value which is output at the central point
+        of the 4 accumulation timespans. This new point is used for linear
+        interpolation of the complete timeseries afterwards.
+
+    @Input:
+        alist: list of size 4, array(2D), type=float
+            List of 4 timespans as 2-dimensional, horizontal fields.
+            E.g. [[array_t1], [array_t2], [array_t3], [array_t4]]
+
+    @Return:
+        nfield: array(2D), type=float
+            New field which replaces the field at the second position
+            of the accumulation timespans.
+
+    '''
+    pya = (alist[3] - alist[0] + 3. * (alist[1] - alist[2])) / 6.
+    pyb = (alist[2] + alist[0]) / 2. - alist[1] - 9. * pya / 2.
+    pyc = alist[1] - alist[0] - 7. * pya / 2. - 2. * pyb
+    pyd = alist[0] - pya / 4. - pyb / 3. - pyc / 2.
+    nfield = 8. * pya + 4. * pyb + 2. * pyc + pyd
+
+    return nfield
+
+
+def darain(alist):
+    '''
+    @Author: P. JAMES
+
+    @Date: 2000-03-29
+
+    @ChangeHistory:
+        June 2003     - A. BECK (2003-06-01)
+            adaptaions
+        November 2015 - Leopold Haimberger (University of Vienna)
+            migration from Fortran to Python
+
+    @Description:
+        Interpolation of deaccumulated fluxes of an ECMWF model FG rainfall
+        field using a modified linear solution which conserves the integrals
+        of the fluxes within each timespan.
+        Disaggregation is done for 4 accumluated timespans which generates
+        a new, disaggregated value which is output at the central point
+        of the 4 accumulation timespans. This new point is used for linear
+        interpolation of the complete timeseries afterwards.
+
+    @Input:
+        alist: list of size 4, array(2D), type=float
+            List of 4 timespans as 2-dimensional, horizontal fields.
+            E.g. [[array_t1], [array_t2], [array_t3], [array_t4]]
+
+    @Return:
+        nfield: array(2D), type=float
+            New field which replaces the field at the second position
+            of the accumulation timespans.
+    '''
+    xa = alist[0]
+    xb = alist[1]
+    xc = alist[2]
+    xd = alist[3]
+    xa[xa < 0.] = 0.
+    xb[xb < 0.] = 0.
+    xc[xc < 0.] = 0.
+    xd[xd < 0.] = 0.
+
+    xac = 0.5 * xb
+    mask = xa + xc > 0.
+    xac[mask] = xb[mask] * xc[mask] / (xa[mask] + xc[mask])
+    xbd = 0.5 * xc
+    mask = xb + xd > 0.
+    xbd[mask] = xb[mask] * xc[mask] / (xb[mask] + xd[mask])
+    nfield = xac + xbd
+
+    return nfield
+
+
+
+
+
+
+
+
+
+
